function box(id,colors,rows,columns)
{
	this.id = id;
	this.colors = colors;
	this.rows = rows;
	this.columns = columns;
	this.selectedColor = '';
	this.colorApplied = [];
	var t = this;
	
	this.init = function(){		
		t.selectedColor = '';
		t.colorApplied = [];
		t.setBox();
		t.setTriger();
		t.setColor();
	}
	
	//randomize elements
	this.random = function(count){	
		var sourceColumn = t.getRanndomColumn();
		var destColumn = t.getRanndomColumn();
		$('#' + t.id + ' tr:nth-child(' + sourceColumn + ') td').last().detach().appendTo('#' + t.id + ' tr:nth-child(' + destColumn + ')');
		$('#' + t.id + ' tr:nth-child(' + destColumn + ') td').first().detach().appendTo('#' + t.id + ' tr:nth-child(' + sourceColumn + ')');
		
		// for small animation
		if(count<t.columns*t.rows)
		{
			setTimeout(function(){		
				count++;
				t.random(count);
			},50);
		}
	}
	
	//get random column count from given input
	this.getRanndomColumn = function(){	
		return Math.floor(Math.random() * t.columns) + 1;	
	}
	
	//set event trigger for elements
	this.setTriger = function(){	
		$('#' + t.id + '-reset').on('click',function(){		
			t.init();		
		});
		
		$('#' + t.id + '-rand').on('click',function(){		
			t.random(1);		
		});
	
		$('#' + t.id + ' td').on('click',function(){		
			if(t.selectedColor=='')
			{
				alert('Please select a color before clicking on box');
			}
			else
			{
				if(!$(this).hasClass('selected'))
				{
					$(this).addClass('selected ' + 'color-' + t.selectedColor);
					$(this).removeClass('default');
					$(this).css({"background-color":t.selectedColor,"border-color":t.selectedColor});
					var cellId = $(this).attr('id');
						t.colorApplied[cellId] = t.selectedColor;
				}
				else
				{
					var cellId = $(this).attr('id');
						
					alert('Already applied ' + t.colorApplied[cellId] + ' color');
				}
			}		
		});		
	}
	
	//set color when click on rdio button
	this.setColor = function(){	
		$('input:radio[name=' + t.id + '-color]').click(function() {
			t.selectedColor = $(this).val();
		});	
	}
	
	//set a initial html
	this.setBox = function(){		
		var innerHtml = '<form name="' +  t.id + '-from" class="buttons">';		
		
		//create radio buttons
		for(k in colors)
		{
			var val = colors[k];
			innerHtml += '<input type="radio" value="' + val + '" name="' + t.id + '-color" id="' + t.id + '-' + val + '"/><label for="' + t.id + '-' + val + '">' + val + '</label>';
		}
		innerHtml += '</form>';
		
		//create table structure for rows and columns
		innerHtml += '<table cellpadding="0" border="0" cellspacing="20">';
		var increment = 1;
		for(var i=1;i<=columns;i++)
		{
			innerHtml += '<tr>';
			for(var j=1;j<=rows;j++)
			{
				innerHtml += '<td id="row-' + i + '-' + j + '" class="default">' + increment + '</td>';
				increment++;
			}
			innerHtml += '</tr>';
		}
		innerHtml += '</table><div class="buttons"><input type="button" value="Randomize" id="' + t.id + '-rand" /><input type="button" value="Reset" id="' + t.id + '-reset" /></div>';
		
		$('#' + t.id).html(innerHtml);
	}	
}